import org.lwjgl.opengl.GLContext;
import org.lwjgl.opengl.GL13;
import java.nio.ByteOrder;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.Display;
import org.lwjgl.util.glu.GLU;
import org.lwjgl.opengl.GL11;
import java.util.List;
import java.awt.image.BufferedImage;
import java.nio.FloatBuffer;
import java.util.Random;
import net.minecraft.client.Minecraft;
import java.nio.IntBuffer;
import java.nio.ByteBuffer;

public class kz
{
    private Water_Config water_config;
    private Shader water;
    private int water_timer;
    private int water_colorMap;
    private int water_reflectedColorMap;
    private int water_stencilMap;
    private int water_color;
    private Shader black;
    private Shader white;
    private int white_inverse_view;
    private Shader transparency;
    private int transp_render_v3;
    private int transp_water;
    private int transp_waterfall;
    private int transp_waterfall_color;
    private int transp_colorMap;
    private int transp_lightMap;
    private int transp_reflectionMap;
    private FBO framebuffer;
    private int fall_counter;
    private double prev_fall;
    private long previous_time;
    private float timer;
    private double last_water_height;
    private int on_ground_delay;
    private ByteBuffer matrixbuffer;
    private ByteBuffer projectionmatrixbuffer;
    private ByteBuffer projectionmatrixbuffer_tmp;
    boolean second_renderpass;
    int third_person;
    boolean view_bbb;
    int[] lastChunk;
    IntBuffer texture_name;
    public static boolean a;
    public static int b;
    private Minecraft r;
    private float s;
    public lv c;
    private int t;
    private ms u;
    private cb v;
    private cb w;
    private cb x;
    private cb y;
    private cb z;
    private cb A;
    private float B;
    private float C;
    private float D;
    private float E;
    private float F;
    private float G;
    private float H;
    private float I;
    private float J;
    private float K;
    private float L;
    private float M;
    private float N;
    private float O;
    private float P;
    public int d;
    private int[] Q;
    private float R;
    private float S;
    private float T;
    private boolean U;
    private double V;
    private double W;
    private double X;
    private long Y;
    private long Z;
    private boolean aa;
    float e;
    float f;
    float g;
    float h;
    private Random ab;
    private int ac;
    float[] i;
    float[] j;
    volatile int k;
    volatile int l;
    FloatBuffer m;
    float n;
    float o;
    float p;
    private float ad;
    private float ae;
    public int q;
    
    public kz(final Minecraft minecraft) {
        this.fall_counter = 0;
        this.prev_fall = 0.0;
        this.previous_time = 0L;
        this.timer = 0.0f;
        this.last_water_height = 0.0;
        this.on_ground_delay = 200;
        this.matrixbuffer = ByteBuffer.allocateDirect(64);
        this.projectionmatrixbuffer = ByteBuffer.allocateDirect(64);
        this.projectionmatrixbuffer_tmp = ByteBuffer.allocateDirect(64);
        this.second_renderpass = true;
        this.third_person = 0;
        this.view_bbb = false;
        this.s = 0.0f;
        this.u = null;
        this.v = new cb();
        this.w = new cb();
        this.x = new cb();
        this.y = new cb();
        this.z = new cb();
        this.A = new cb();
        this.B = 4.0f;
        this.C = 4.0f;
        this.D = 0.0f;
        this.E = 0.0f;
        this.F = 0.0f;
        this.G = 0.0f;
        this.M = 0.0f;
        this.N = 0.0f;
        this.O = 0.0f;
        this.P = 0.0f;
        this.U = false;
        this.V = 1.0;
        this.W = 0.0;
        this.X = 0.0;
        this.Y = System.currentTimeMillis();
        this.Z = 0L;
        this.aa = false;
        this.e = 0.0f;
        this.f = 0.0f;
        this.g = 0.0f;
        this.h = 0.0f;
        this.ab = new Random();
        this.ac = 0;
        this.k = 0;
        this.l = 0;
        this.m = ep.e(16);
        this.r = minecraft;
        this.c = new lv(minecraft);
        this.d = minecraft.p.a(new BufferedImage(16, 16, 1));
        this.Q = new int[256];
        this.water_config = new Water_Config();
        if (this.water_config.water_render_mode == 1) {
            this.second_renderpass = false;
        }
        else {
            this.second_renderpass = true;
        }
        this.r.A.h = false;
        this.water = new Shader("/shader/water");
        this.water_timer = this.water.initValue1f("timer");
        this.water_colorMap = this.water.initValue1i("colorMap");
        this.water_reflectedColorMap = this.water.initValue1i("reflectedColorMap");
        this.water_stencilMap = this.water.initValue1i("stencilMap");
        this.water_color = this.water.initValueVec3f("water_color");
        this.black = new Shader("/shader/color_black");
        this.white = new Shader("/shader/color_white");
        this.white_inverse_view = this.white.initValueMat4f("inverse_view");
        this.transparency = new Shader("/shader/transparency");
        this.transp_render_v3 = this.transparency.initValue1f("setting_v3");
        this.transp_water = this.transparency.initValue1f("water_transparency");
        this.transp_waterfall = this.transparency.initValue1f("waterfall_transparency");
        this.transp_waterfall_color = this.transparency.initValue1f("waterfall_color");
        this.transp_colorMap = this.transparency.initValue1i("colorMap");
        this.transp_lightMap = this.transparency.initValue1i("pseudoLightMap");
        this.transp_reflectionMap = this.transparency.initValue1i("pseudoReflections");
        this.framebuffer = new FBO(this.r.d, this.r.e, this.water_config.reflection_resolution, this.water_config.anti_aliasing);
    }
    
    public void a() {
        this.c();
        this.d();
        this.ad = this.ae;
        this.C = this.B;
        this.E = this.D;
        this.G = this.F;
        this.N = this.M;
        this.P = this.O;
        if (this.r.A.I) {
            final float f = this.r.A.c * 0.6f + 0.2f;
            final float f2 = f * f * f * 8.0f;
            this.J = this.v.a(this.H, 0.05f * f2);
            this.K = this.w.a(this.I, 0.05f * f2);
            this.L = 0.0f;
            this.H = 0.0f;
            this.I = 0.0f;
        }
        if (this.r.i == null) {
            this.r.i = (aar)this.r.h;
        }
        final float f3 = this.r.f.c(ga.c(this.r.i.o), ga.c(this.r.i.p), ga.c(this.r.i.q));
        final float f4 = (3 - this.r.A.e) / 3.0f;
        final float f5 = f3 * (1.0f - f4) + f4;
        this.ae += (f5 - this.ae) * 0.1f;
        ++this.t;
        this.c.a();
        this.f();
    }
    
    public void a(final float f) {
        if (this.r.i == null) {
            return;
        }
        if (this.r.f == null) {
            return;
        }
        double d = this.r.c.b();
        this.r.z = this.r.i.a(d, f);
        double d2 = d;
        final bk vec3d = this.r.i.h(f);
        if (this.r.z != null) {
            d2 = this.r.z.f.d(vec3d);
        }
        if (this.r.c.i()) {
            d = (d2 = 6.0);
        }
        else {
            if (d2 > 3.0) {
                d2 = 3.0;
            }
            d = d2;
        }
        final bk vec3d2 = this.r.i.i(f);
        final bk vec3d3 = vec3d.c(vec3d2.a * d, vec3d2.b * d, vec3d2.c * d);
        this.u = null;
        final float f2 = 1.0f;
        final List list = this.r.f.b((ms)this.r.i, this.r.i.y.a(vec3d2.a * d, vec3d2.b * d, vec3d2.c * d).b((double)f2, (double)f2, (double)f2));
        double d3 = 0.0;
        for (int i = 0; i < list.size(); ++i) {
            final ms entity = list.get(i);
            if (entity.d_()) {
                final float f3 = entity.i_();
                final vi axisalignedbb = entity.y.b((double)f3, (double)f3, (double)f3);
                final on movingobjectposition = axisalignedbb.a(vec3d, vec3d3);
                if (axisalignedbb.a(vec3d)) {
                    if (0.0 < d3 || d3 == 0.0) {
                        this.u = entity;
                        d3 = 0.0;
                    }
                }
                else if (movingobjectposition != null) {
                    final double d4 = vec3d.d(movingobjectposition.f);
                    if (d4 < d3 || d3 == 0.0) {
                        this.u = entity;
                        d3 = d4;
                    }
                }
            }
        }
        if (this.u != null) {
            this.r.z = new on(this.u);
        }
    }
    
    private void c() {
        final uh entityplayersp = (uh)this.r.i;
        this.T = entityplayersp.z_();
        this.S = this.R;
        this.R += (this.T - this.R) * 0.5f;
    }
    
    private float a(final float f, final boolean flag) {
        if (this.q > 0) {
            return 90.0f;
        }
        final xb entityplayer = (xb)this.r.i;
        float f2 = 70.0f;
        if (flag) {
            f2 += this.r.A.M * 40.0f;
            f2 *= this.S + (this.R - this.S) * f;
        }
        if (entityplayer.aP() <= 0) {
            final float f3 = entityplayer.bD + f;
            f2 /= (1.0f - 500.0f / (f3 + 500.0f)) * 2.0f + 1.0f;
        }
        final int i = yx.a(this.r.f, (aar)entityplayer, f);
        if (i != 0 && oe.m[i].cb == null) {
            f2 = f2 * 60.0f / 70.0f;
        }
        return f2 + this.N + (this.M - this.N) * f;
    }
    
    private void d(final float f) {
        final aar entityliving = this.r.i;
        float f2 = entityliving.bA - f;
        if (entityliving.aP() <= 0) {
            final float f3 = entityliving.bD + f;
            GL11.glRotatef(40.0f - 8000.0f / (f3 + 200.0f), 0.0f, 0.0f, 1.0f);
        }
        if (f2 < 0.0f) {
            return;
        }
        f2 /= entityliving.bB;
        f2 = ga.a(f2 * f2 * f2 * f2 * 3.141593f);
        final float f4 = entityliving.bC;
        GL11.glRotatef(-f4, 0.0f, 1.0f, 0.0f);
        GL11.glRotatef(-f2 * 14.0f, 0.0f, 0.0f, 1.0f);
        GL11.glRotatef(f4, 0.0f, 1.0f, 0.0f);
    }
    
    private void e(final float f) {
        if (!(this.r.i instanceof xb)) {
            return;
        }
        final xb entityplayer = (xb)this.r.i;
        final float f2 = entityplayer.L - entityplayer.K;
        final float f3 = -(entityplayer.L + f2 * f);
        final float f4 = entityplayer.aw + (entityplayer.ax - entityplayer.aw) * f;
        final float f5 = entityplayer.bF + (entityplayer.bG - entityplayer.bF) * f;
        GL11.glTranslatef(ga.a(f3 * 3.141593f) * f4 * 0.5f, -Math.abs(ga.b(f3 * 3.141593f) * f4), 0.0f);
        GL11.glRotatef(ga.a(f3 * 3.141593f) * f4 * 3.0f, 0.0f, 0.0f, 1.0f);
        GL11.glRotatef(Math.abs(ga.b(f3 * 3.141593f - 0.2f) * f4) * 5.0f, 1.0f, 0.0f, 0.0f);
        GL11.glRotatef(f5, 1.0f, 0.0f, 0.0f);
    }
    
    private void f(final float f) {
        final aar entityliving = this.r.i;
        float f2 = entityliving.H - 1.62f;
        double d = entityliving.l + (entityliving.o - entityliving.l) * f;
        double d2 = entityliving.m + (entityliving.p - entityliving.m) * f - f2;
        double d3 = entityliving.n + (entityliving.q - entityliving.n) * f;
        GL11.glRotatef(this.P + (this.O - this.P) * f, 0.0f, 0.0f, 1.0f);
        if (entityliving.ay()) {
            ++f2;
            GL11.glTranslatef(0.0f, 0.3f, 0.0f);
            if (!this.r.A.J) {
                final int i = this.r.f.a(ga.c(entityliving.o), ga.c(entityliving.p), ga.c(entityliving.q));
                if (i == oe.U.bO) {
                    final int j = this.r.f.e(ga.c(entityliving.o), ga.c(entityliving.p), ga.c(entityliving.q));
                    final int k = j & 0x3;
                    GL11.glRotatef((float)(k * 90), 0.0f, 1.0f, 0.0f);
                }
                GL11.glRotatef(entityliving.w + (entityliving.u - entityliving.w) * f + 180.0f, 0.0f, -1.0f, 0.0f);
                GL11.glRotatef(entityliving.x + (entityliving.v - entityliving.x) * f, -1.0f, 0.0f, 0.0f);
            }
        }
        else if (this.r.A.E > 0) {
            double d4 = this.C + (this.B - this.C) * f;
            if (this.r.A.J) {
                final float f3 = this.E + (this.D - this.E) * f;
                final float f4 = this.G + (this.F - this.G) * f;
                GL11.glTranslatef(0.0f, 0.0f, (float)(-d4));
                GL11.glRotatef(f4, 1.0f, 0.0f, 0.0f);
                GL11.glRotatef(f3, 0.0f, 1.0f, 0.0f);
            }
            else {
                final float f5 = entityliving.u;
                float f6 = entityliving.v;
                if (this.r.A.E == 2) {
                    f6 += 180.0f;
                }
                final double d5 = -ga.a(f5 / 180.0f * 3.141593f) * ga.b(f6 / 180.0f * 3.141593f) * d4;
                final double d6 = ga.b(f5 / 180.0f * 3.141593f) * ga.b(f6 / 180.0f * 3.141593f) * d4;
                final double d7 = -ga.a(f6 / 180.0f * 3.141593f) * d4;
                for (int l = 0; l < 8; ++l) {
                    float f7 = (float)((l & 0x1) * 2 - 1);
                    float f8 = (float)((l >> 1 & 0x1) * 2 - 1);
                    float f9 = (float)((l >> 2 & 0x1) * 2 - 1);
                    f7 *= 0.1f;
                    f8 *= 0.1f;
                    f9 *= 0.1f;
                    final on movingobjectposition = this.r.f.a(bk.b(d + f7, d2 + f8, d3 + f9), bk.b(d - d5 + f7 + f9, d2 - d7 + f8, d3 - d6 + f9));
                    if (movingobjectposition != null) {
                        final double d8 = movingobjectposition.f.d(bk.b(d, d2, d3));
                        if (d8 < d4) {
                            d4 = d8;
                        }
                    }
                }
                if (this.r.A.E == 2) {
                    GL11.glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
                }
                GL11.glRotatef(entityliving.v - f6, 1.0f, 0.0f, 0.0f);
                GL11.glRotatef(entityliving.u - f5, 0.0f, 1.0f, 0.0f);
                GL11.glTranslatef(0.0f, 0.0f, (float)(-d4));
                GL11.glRotatef(f5 - entityliving.u, 0.0f, 1.0f, 0.0f);
                GL11.glRotatef(f6 - entityliving.v, 1.0f, 0.0f, 0.0f);
            }
        }
        else {
            GL11.glTranslatef(0.0f, 0.0f, -0.1f);
        }
        if (!this.r.A.J) {
            GL11.glRotatef(entityliving.x + (entityliving.v - entityliving.x) * f, 1.0f, 0.0f, 0.0f);
            GL11.glRotatef(entityliving.w + (entityliving.u - entityliving.w) * f + 180.0f, 0.0f, 1.0f, 0.0f);
        }
        GL11.glTranslatef(0.0f, f2, 0.0f);
        d = entityliving.l + (entityliving.o - entityliving.l) * f;
        d2 = entityliving.m + (entityliving.p - entityliving.m) * f - f2;
        d3 = entityliving.n + (entityliving.q - entityliving.n) * f;
        this.U = this.r.g.a(d, d2, d3, f);
    }
    
    private void a(final float f, final int i) {
        this.s = (float)(256 >> this.r.A.e);
        GL11.glMatrixMode(5889);
        GL11.glLoadIdentity();
        final float f2 = 0.07f;
        if (this.r.A.g) {
            GL11.glTranslatef(-(i * 2 - 1) * f2, 0.0f, 0.0f);
        }
        if (this.V != 1.0) {
            GL11.glTranslatef((float)this.W, (float)(-this.X), 0.0f);
            GL11.glScaled(this.V, this.V, 1.0);
            GLU.gluPerspective(this.a(f, true), this.r.d / (float)this.r.e, 0.05f, this.s * 2.0f);
        }
        else {
            GLU.gluPerspective(this.a(f, true), this.r.d / (float)this.r.e, 0.05f, this.s * 2.0f);
        }
        if (this.r.c.e()) {
            final float f3 = 0.6666667f;
            GL11.glScalef(1.0f, f3, 1.0f);
        }
        GL11.glMatrixMode(5888);
        GL11.glLoadIdentity();
        if (this.r.A.g) {
            GL11.glTranslatef((i * 2 - 1) * 0.1f, 0.0f, 0.0f);
        }
        this.d(f);
        if (this.r.A.f) {
            this.e(f);
        }
        final float f4 = this.r.h.aS + (this.r.h.aR - this.r.h.aS) * f;
        if (f4 > 0.0f) {
            int j = 20;
            if (this.r.h.a(yg.k)) {
                j = 7;
            }
            float f5 = 5.0f / (f4 * f4 + 5.0f) - f4 * 0.04f;
            f5 *= f5;
            GL11.glRotatef((this.t + f) * j, 0.0f, 1.0f, 1.0f);
            GL11.glScalef(1.0f / f5, 1.0f, 1.0f);
            GL11.glRotatef(-(this.t + f) * j, 0.0f, 1.0f, 1.0f);
        }
        this.f(f);
        if (this.q > 0) {
            final int k = this.q - 1;
            if (k == 1) {
                GL11.glRotatef(90.0f, 0.0f, 1.0f, 0.0f);
            }
            if (k == 2) {
                GL11.glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
            }
            if (k == 3) {
                GL11.glRotatef(-90.0f, 0.0f, 1.0f, 0.0f);
            }
            if (k == 4) {
                GL11.glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
            }
            if (k == 5) {
                GL11.glRotatef(-90.0f, 1.0f, 0.0f, 0.0f);
            }
        }
    }
    
    private void b(final float f, final int i) {
        if (this.q > 0) {
            return;
        }
        GL11.glMatrixMode(5889);
        GL11.glLoadIdentity();
        final float f2 = 0.07f;
        if (this.r.A.g) {
            GL11.glTranslatef(-(i * 2 - 1) * f2, 0.0f, 0.0f);
        }
        if (this.V != 1.0) {
            GL11.glTranslatef((float)this.W, (float)(-this.X), 0.0f);
            GL11.glScaled(this.V, this.V, 1.0);
            GLU.gluPerspective(this.a(f, false), this.r.d / (float)this.r.e, 0.05f, this.s * 2.0f);
        }
        else {
            GLU.gluPerspective(this.a(f, false), this.r.d / (float)this.r.e, 0.05f, this.s * 2.0f);
        }
        if (this.r.c.e()) {
            final float f3 = 0.6666667f;
            GL11.glScalef(1.0f, f3, 1.0f);
        }
        GL11.glMatrixMode(5888);
        GL11.glLoadIdentity();
        if (this.r.A.g) {
            GL11.glTranslatef((i * 2 - 1) * 0.1f, 0.0f, 0.0f);
        }
        GL11.glPushMatrix();
        this.d(f);
        if (this.r.A.f) {
            this.e(f);
        }
        if (this.r.A.E == 0 && !this.r.i.ay() && !this.r.A.D && !this.r.c.e()) {
            this.b((double)f);
            this.c.a(f);
            this.a((double)f);
        }
        GL11.glPopMatrix();
        if (this.r.A.E == 0 && !this.r.i.ay()) {
            this.c.b(f);
            this.d(f);
        }
        if (this.r.A.f) {
            this.e(f);
        }
    }
    
    public void a(final double d) {
        em.a(em.b);
        GL11.glDisable(3553);
        em.a(em.a);
    }
    
    public void b(final double d) {
        em.a(em.b);
        GL11.glMatrixMode(5890);
        GL11.glLoadIdentity();
        final float f = 0.00390625f;
        GL11.glScalef(f, f, f);
        GL11.glTranslatef(8.0f, 8.0f, 8.0f);
        GL11.glMatrixMode(5888);
        this.r.p.b(this.d);
        GL11.glTexParameteri(3553, 10241, 9729);
        GL11.glTexParameteri(3553, 10240, 9729);
        GL11.glTexParameteri(3553, 10241, 9729);
        GL11.glTexParameteri(3553, 10240, 9729);
        GL11.glTexParameteri(3553, 10242, 10496);
        GL11.glTexParameteri(3553, 10243, 10496);
        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        GL11.glEnable(3553);
        em.a(em.a);
    }
    
    private void d() {
        this.f += (float)((Math.random() - Math.random()) * Math.random() * Math.random());
        this.h += (float)((Math.random() - Math.random()) * Math.random() * Math.random());
        this.f *= (float)0.9;
        this.h *= (float)0.9;
        this.e += (this.f - this.e) * 1.0f;
        this.g += (this.h - this.g) * 1.0f;
        this.aa = true;
    }
    
    private void e() {
        final vq world = this.r.f;
        if (world == null) {
            return;
        }
        for (int i = 0; i < 256; ++i) {
            final float f = world.b(1.0f) * 0.95f + 0.05f;
            float f2 = world.y.g[i / 16] * f;
            final float f3 = world.y.g[i % 16] * (this.e * 0.1f + 1.5f);
            if (world.s > 0) {
                f2 = world.y.g[i / 16];
            }
            final float f4 = f2 * (world.b(1.0f) * 0.65f + 0.35f);
            final float f5 = f2 * (world.b(1.0f) * 0.65f + 0.35f);
            final float f6 = f2;
            final float f7 = f3;
            final float f8 = f3 * ((f3 * 0.6f + 0.4f) * 0.6f + 0.4f);
            final float f9 = f3 * (f3 * f3 * 0.6f + 0.4f);
            float f10 = f4 + f7;
            float f11 = f5 + f8;
            float f12 = f6 + f9;
            f10 = f10 * 0.96f + 0.03f;
            f11 = f11 * 0.96f + 0.03f;
            f12 = f12 * 0.96f + 0.03f;
            if (world.y.h == 1) {
                f10 = 0.22f + f7 * 0.75f;
                f11 = 0.28f + f8 * 0.75f;
                f12 = 0.25f + f9 * 0.75f;
            }
            final float f13 = this.r.A.N;
            if (f10 > 1.0f) {
                f10 = 1.0f;
            }
            if (f11 > 1.0f) {
                f11 = 1.0f;
            }
            if (f12 > 1.0f) {
                f12 = 1.0f;
            }
            float f14 = 1.0f - f10;
            float f15 = 1.0f - f11;
            float f16 = 1.0f - f12;
            f14 = 1.0f - f14 * f14 * f14 * f14;
            f15 = 1.0f - f15 * f15 * f15 * f15;
            f16 = 1.0f - f16 * f16 * f16 * f16;
            f10 = f10 * (1.0f - f13) + f14 * f13;
            f11 = f11 * (1.0f - f13) + f15 * f13;
            f12 = f12 * (1.0f - f13) + f16 * f13;
            f10 = f10 * 0.96f + 0.03f;
            f11 = f11 * 0.96f + 0.03f;
            f12 = f12 * 0.96f + 0.03f;
            if (f10 > 1.0f) {
                f10 = 1.0f;
            }
            if (f11 > 1.0f) {
                f11 = 1.0f;
            }
            if (f12 > 1.0f) {
                f12 = 1.0f;
            }
            if (f10 < 0.0f) {
                f10 = 0.0f;
            }
            if (f11 < 0.0f) {
                f11 = 0.0f;
            }
            if (f12 < 0.0f) {
                f12 = 0.0f;
            }
            final char c = 'ÿ';
            final int j = (int)(f10 * 255.0f);
            final int k = (int)(f11 * 255.0f);
            final int l = (int)(f12 * 255.0f);
            this.Q[i] = (c << 24 | j << 16 | k << 8 | l);
        }
        this.r.p.a(this.Q, 16, 16, this.d);
    }
    
    public void b(final float f) {
        ld.a("lightTex");
        if (this.aa) {
            this.e();
        }
        ld.b();
        if (!Display.isActive()) {
            if (System.currentTimeMillis() - this.Y > 500L) {
                this.r.i();
            }
        }
        else {
            this.Y = System.currentTimeMillis();
        }
        ld.a("mouse");
        if (this.r.R) {
            this.r.D.c();
            final float f2 = this.r.A.c * 0.6f + 0.2f;
            final float f3 = f2 * f2 * f2 * 8.0f;
            float f4 = this.r.D.a * f3;
            float f5 = this.r.D.b * f3;
            int l = 1;
            if (this.r.A.d) {
                l = -1;
            }
            if (this.r.A.I) {
                this.H += f4;
                this.I += f5;
                final float f6 = f - this.L;
                this.L = f;
                f4 = this.J * f6;
                f5 = this.K * f6;
                this.r.h.c(f4, f5 * l);
            }
            else {
                this.r.h.c(f4, f5 * l);
            }
        }
        ld.b();
        if (this.r.x) {
            return;
        }
        kz.a = this.r.A.g;
        final aec scaledresolution = new aec(this.r.A, this.r.d, this.r.e);
        final int i = scaledresolution.a();
        final int j = scaledresolution.b();
        final int k = Mouse.getX() * i / this.r.d;
        final int i2 = j - Mouse.getY() * j / this.r.e - 1;
        char c = 'È';
        if (this.r.A.i == 1) {
            c = 'x';
        }
        if (this.r.A.i == 2) {
            c = '(';
        }
        if (this.r.f != null) {
            ld.a("level");
            if (this.r.A.i == 0) {
                this.a(f, 0L);
            }
            else {
                this.a(f, this.Z + 1000000000 / c);
            }
            ld.c("sleep");
            if (this.r.A.i == 2) {
                final long l2 = (this.Z + 1000000000 / c - System.nanoTime()) / 1000000L;
                if (l2 > 0L && l2 < 500L) {
                    try {
                        Thread.sleep(l2);
                    }
                    catch (final InterruptedException interruptedexception) {
                        interruptedexception.printStackTrace();
                    }
                }
            }
            this.Z = System.nanoTime();
            ld.c("gui");
            if (!this.r.A.D || this.r.s != null) {
                this.r.w.a(f, this.r.s != null, k, i2);
            }
            ld.b();
        }
        else {
            GL11.glViewport(0, 0, this.r.d, this.r.e);
            GL11.glMatrixMode(5889);
            GL11.glLoadIdentity();
            GL11.glMatrixMode(5888);
            GL11.glLoadIdentity();
            this.b();
            if (this.r.A.i == 2) {
                long l3 = (this.Z + 1000000000 / c - System.nanoTime()) / 1000000L;
                if (l3 < 0L) {
                    l3 += 10L;
                }
                if (l3 > 0L && l3 < 500L) {
                    try {
                        Thread.sleep(l3);
                    }
                    catch (final InterruptedException interruptedexception2) {
                        interruptedexception2.printStackTrace();
                    }
                }
            }
            this.Z = System.nanoTime();
        }
        if (this.r.s != null) {
            GL11.glClear(256);
            this.r.s.a(k, i2, f);
            if (this.r.s != null && this.r.s.v != null) {
                this.r.s.v.a(f);
            }
        }
    }
    
    private float[] negateTransposeMatrix(final float[] matrix) {
        return new float[] { -matrix[0], -matrix[4], -matrix[8], -matrix[12], -matrix[1], -matrix[5], -matrix[9], -matrix[13], -matrix[2], -matrix[6], -matrix[10], -matrix[14], -matrix[3], -matrix[7], -matrix[11], -matrix[15] };
    }
    
    private float[] calcView(final double tx, final double ty, final double tz, double yaw, double pitch) {
        pitch = Math.toRadians(pitch);
        yaw = Math.toRadians(yaw);
        float[] out = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_pitch = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, (float)Math.cos(pitch), (float)(-Math.sin(pitch)), 0.0f, 0.0f, (float)Math.sin(pitch), (float)Math.cos(pitch), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_yaw = { (float)Math.cos(yaw), 0.0f, (float)Math.sin(yaw), 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, (float)(-Math.sin(yaw)), 0.0f, (float)Math.cos(yaw), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] translate = { 1.0f, 0.0f, 0.0f, (float)tx, 0.0f, 1.0f, 0.0f, (float)ty, 0.0f, 0.0f, 1.0f, (float)tz, 0.0f, 0.0f, 0.0f, 1.0f };
        out = this.multMatrix(translate, this.multMatrix(r_yaw, this.multMatrix(r_pitch, out)));
        return out;
    }
    
    private float[] calcInverseView(final double tx, final double ty, final double tz, double yaw, double pitch) {
        pitch = Math.toRadians(pitch);
        yaw = Math.toRadians(yaw);
        float[] out = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_pitch = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, (float)Math.cos(-pitch), (float)(-Math.sin(-pitch)), 0.0f, 0.0f, (float)Math.sin(-pitch), (float)Math.cos(-pitch), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_yaw = { (float)Math.cos(-yaw), 0.0f, (float)Math.sin(-yaw), 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, (float)(-Math.sin(-yaw)), 0.0f, (float)Math.cos(-yaw), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] translate = { 1.0f, 0.0f, 0.0f, (float)(-tx), 0.0f, 1.0f, 0.0f, (float)(-ty), 0.0f, 0.0f, 1.0f, (float)(-tz), 0.0f, 0.0f, 0.0f, 1.0f };
        out = this.multMatrix(translate, this.multMatrix(r_yaw, this.multMatrix(r_pitch, out)));
        return out;
    }
    
    private float[] calcViewVector(double yaw, double pitch) {
        pitch = Math.toRadians(pitch);
        yaw = Math.toRadians(yaw);
        float[] out = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_pitch = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, (float)Math.cos(-pitch), (float)(-Math.sin(-pitch)), 0.0f, 0.0f, (float)Math.sin(-pitch), (float)Math.cos(-pitch), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        final float[] r_yaw = { (float)Math.cos(-yaw), 0.0f, (float)Math.sin(-yaw), 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, (float)(-Math.sin(-yaw)), 0.0f, (float)Math.cos(-yaw), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        out = this.multMatrix(r_pitch, this.multMatrix(r_yaw, out));
        return out;
    }
    
    private float[] multMatrix(final float[] l, final float[] r) {
        final float[] out = { l[0] * r[0] + l[1] * r[4] + l[2] * r[8] + l[3] * r[12], l[0] * r[1] + l[1] * r[5] + l[2] * r[9] + l[3] * r[13], l[0] * r[2] + l[1] * r[6] + l[2] * r[10] + l[3] * r[14], l[0] * r[3] + l[1] * r[7] + l[2] * r[11] + l[3] * r[15], l[4] * r[0] + l[5] * r[4] + l[6] * r[8] + l[7] * r[12], l[4] * r[1] + l[5] * r[5] + l[6] * r[9] + l[7] * r[13], l[4] * r[2] + l[5] * r[6] + l[6] * r[10] + l[7] * r[14], l[4] * r[3] + l[5] * r[7] + l[6] * r[11] + l[7] * r[15], l[8] * r[0] + l[9] * r[4] + l[10] * r[8] + l[11] * r[12], l[8] * r[1] + l[9] * r[5] + l[10] * r[9] + l[11] * r[13], l[8] * r[2] + l[9] * r[6] + l[10] * r[10] + l[11] * r[14], l[8] * r[3] + l[9] * r[7] + l[10] * r[11] + l[11] * r[15], l[12] * r[0] + l[13] * r[4] + l[14] * r[8] + l[15] * r[12], l[12] * r[1] + l[13] * r[5] + l[14] * r[9] + l[15] * r[13], l[12] * r[2] + l[13] * r[6] + l[14] * r[10] + l[15] * r[14], l[12] * r[3] + l[13] * r[7] + l[14] * r[11] + l[15] * r[15] };
        return out;
    }
    
    private float[] multMatrixVector(final float[] matrix, final float[] vector) {
        final float[] out = { matrix[0] * vector[0] + matrix[4] * vector[1] + matrix[8] * vector[2] + matrix[12] * vector[3], matrix[1] * vector[0] + matrix[5] * vector[1] + matrix[9] * vector[2] + matrix[13] * vector[3], matrix[2] * vector[0] + matrix[6] * vector[1] + matrix[10] * vector[2] + matrix[14] * vector[3], matrix[3] * vector[0] + matrix[7] * vector[1] + matrix[11] * vector[2] + matrix[15] * vector[3] };
        return out;
    }
    
    private float[] transpose(final float[] matrix) {
        final float[] out = { matrix[0], matrix[4], matrix[8], matrix[12], matrix[1], matrix[5], matrix[9], matrix[13], matrix[2], matrix[6], matrix[10], matrix[14], matrix[3], matrix[7], matrix[11], matrix[15] };
        return out;
    }
    
    private float[] inverseOrth(final float[] matrix) {
        final float[] out = { matrix[0], matrix[4], matrix[8], 0.0f, matrix[1], matrix[5], matrix[9], 0.0f, matrix[2], matrix[6], matrix[10], 0.0f, -matrix[12] * matrix[0] - matrix[13] * matrix[1] - matrix[14] * matrix[2], -matrix[12] * matrix[4] - matrix[13] * matrix[5] - matrix[14] * matrix[6], -matrix[12] * matrix[8] - matrix[13] * matrix[9] - matrix[14] * matrix[10], 1.0f };
        return out;
    }
    
    private void modifyProjectionMatrix(final double height) {
        final ByteBuffer clipbuf = ByteBuffer.allocateDirect(32);
        clipbuf.clear();
        clipbuf.order(ByteOrder.nativeOrder());
        clipbuf.asDoubleBuffer().put(new double[] { 0.0, 1.0, 0.0, height });
        GL11.glClipPlane(12288, clipbuf.asDoubleBuffer());
        GL11.glEnable(12288);
    }
    
    private float[] applyViewBobbing(float[] matrix, final float f) {
        final xb entityplayer = (xb)this.r.i;
        final float f2 = entityplayer.L - entityplayer.K;
        final float f3 = -(entityplayer.L + f2 * f);
        final float f4 = entityplayer.aw + (entityplayer.ax - entityplayer.aw) * f;
        final float f5 = entityplayer.bF + (entityplayer.bG - entityplayer.bF) * f;
        final float[] translate = { 1.0f, 0.0f, 0.0f, ga.a(f3 * 3.141593f) * f4 * 0.5f, 0.0f, 1.0f, 0.0f, -Math.abs(ga.b(f3 * 3.141593f) * f4), 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        double angle = Math.toRadians(ga.a(f3 * 3.141593f) * f4 * 3.0f);
        final float[] rot1 = { (float)Math.cos(angle), 0.0f, (float)Math.sin(angle), 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, (float)(-Math.sin(angle)), 0.0f, (float)Math.cos(angle), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        angle = Math.toRadians(Math.abs(ga.b(f3 * 3.141593f - 0.2f) * f4) * 5.0f);
        final float[] rot2 = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, (float)Math.cos(angle), (float)(-Math.sin(angle)), 0.0f, 0.0f, (float)Math.sin(angle), (float)Math.cos(angle), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        angle = Math.toRadians(f5);
        final float[] rot3 = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, (float)Math.cos(angle), (float)(-Math.sin(angle)), 0.0f, 0.0f, (float)Math.sin(angle), (float)Math.cos(angle), 0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
        matrix = this.multMatrix(rot3, this.multMatrix(rot2, this.multMatrix(rot1, this.multMatrix(translate, matrix))));
        return matrix;
    }
    
    private double find_closest_water_height(final double x, final double y, final double z, double azimuth) {
        double out = 0.0;
        final double x_radius = 32.0;
        final double dx = 1.0;
        final double z_radius = 32.0;
        final double dz = 1.0;
        final double y_radius = 12.0;
        final double dy = 1.0;
        if (azimuth < 0.0) {
            azimuth += 360.0;
        }
        final double[] cases = { 1.0, 1.0, 1.0, 1.0 };
        if (azimuth > 315.0 || azimuth < 45.0) {
            cases[0] = 0.125;
        }
        if (azimuth > 135.0 && azimuth < 225.0) {
            cases[1] = 0.125;
        }
        if (azimuth > 225.0 && azimuth < 325.0) {
            cases[2] = 0.125;
        }
        if (azimuth > 45.0 && azimuth < 135.0) {
            cases[3] = 0.125;
        }
        for (double cy = y; cy > y - y_radius; cy -= dy) {
            for (double cz = z - z_radius * cases[0]; cz < z + z_radius * cases[1]; cz += dz) {
                for (double cx = x - x_radius * cases[2]; cx < x + x_radius * cases[3]; cx += dx) {
                    if (this.r.f.a((int)cx, (int)cy, (int)cz) == 9) {
                        final int metad = this.r.f.e((int)cx, (int)cy, (int)cz);
                        if (metad == 0 || metad == 0) {
                            return out = cy;
                        }
                    }
                }
            }
        }
        return out;
    }
    
    private double planeCasting(final double x, final double y, final double z) {
        final bk depth_v = bk.b(this.r.i.S().a, this.r.i.S().b, this.r.i.S().c);
        final bk side_v = bk.b(depth_v.c, depth_v.b, -depth_v.a);
        final bk up_v = side_v.c(depth_v).c();
        final double[] dp = { 0.800000011920929, 0.009999999776482582, 0.009999999776482582 };
        final double[] vp = { 0.800000011920929, 0.02500000037252903, 0.02500000037252903 };
        final int dim_x = 28;
        final int dim_y = 28;
        final int dim_depth = 30;
        final boolean[][] view_plane_points = new boolean[2 * dim_x][2 * dim_y];
        for (int i = 0; i < dim_y; ++i) {
            for (int j = 0; j < dim_y; ++j) {
                view_plane_points[i][j] = true;
            }
        }
        for (int k = 1; k < dim_depth; ++k) {
            final double dx = x + k * depth_v.a * dp[0];
            final double dy = y + k * depth_v.b * dp[0];
            final double dz = z + k * depth_v.c * dp[0];
            for (int l = -dim_y; l < dim_y; ++l) {
                final double hx = dx - l * up_v.a * dp[1];
                final double hy = dy - l * up_v.b * dp[1];
                final double hz = dz - l * up_v.c * dp[1];
                for (int m = 0; m < dim_x; ++m) {
                    if (view_plane_points[dim_x - m][dim_y + l]) {
                        final double lx = hx - m * side_v.a * dp[2];
                        final double ly = hy - m * side_v.b * dp[2];
                        final double lz = hz - m * side_v.c * dp[2];
                        final int type = this.r.f.a((int)lx, (int)ly, (int)lz);
                        if (type == 9) {
                            final int metad = this.r.f.e((int)lx, (int)ly, (int)lz);
                            if (metad == 0) {
                                return Math.floor(ly) + 0.5 + 0.62000000476837;
                            }
                        }
                        else if (type != 0) {
                            view_plane_points[dim_x - m][dim_y + l] = false;
                        }
                    }
                    if (view_plane_points[dim_x + m][dim_y + l]) {
                        final double lx = hx + m * side_v.a * dp[2];
                        final double ly = hy + m * side_v.b * dp[2];
                        final double lz = hz + m * side_v.c * dp[2];
                        final int type = this.r.f.a((int)lx, (int)ly, (int)lz);
                        if (type == 9) {
                            final int metad = this.r.f.e((int)lx, (int)ly, (int)lz);
                            if (metad == 0) {
                                return Math.floor(ly) + 0.62000000476837;
                            }
                        }
                        else if (type != 0) {
                            view_plane_points[dim_x + m][dim_y + l] = false;
                        }
                    }
                }
            }
            final double[] array = dp;
            final int n = 1;
            array[n] += vp[1];
            final double[] array2 = dp;
            final int n2 = 2;
            array2[n2] += vp[2];
        }
        return 0.0;
    }
    
    public void a(final float f, final long l) {
        ld.a("lightTex");
        if (this.aa) {
            this.e();
        }
        GL11.glEnable(2884);
        GL11.glEnable(2929);
        if (this.r.i == null) {
            this.r.i = (aar)this.r.h;
        }
        ld.c("pick");
        this.a(f);
        final aar entityliving = this.r.i;
        final l renderglobal = this.r.g;
        final cq effectrenderer = this.r.j;
        final double d = entityliving.N + (entityliving.o - entityliving.N) * f;
        final double d2 = entityliving.O + (entityliving.p - entityliving.O) * f;
        final double d3 = entityliving.P + (entityliving.q - entityliving.P) * f;
        ld.c("center");
        final bs ichunkprovider = this.r.f.x();
        if (ichunkprovider instanceof hj) {
            final hj chunkproviderloadorgenerate = (hj)ichunkprovider;
            final int j = ga.d((float)(int)d) >> 4;
            final int k = ga.d((float)(int)d3) >> 4;
            chunkproviderloadorgenerate.d(j, k);
        }
        boolean disable_terrain = false;
        this.framebuffer.updateFBOsize(this.r.d, this.r.e);
        for (int i = 0; i < this.water_config.water_render_mode; ++i) {
            if (this.r.A.g) {
                this.second_renderpass = false;
                kz.b = i;
                if (kz.b == 0) {
                    GL11.glColorMask(false, true, true, false);
                }
                else {
                    GL11.glColorMask(true, false, false, false);
                }
            }
            ld.c("clear");
            if (this.second_renderpass) {
                this.framebuffer.bind(i);
                if (i == 1) {
                    disable_terrain = true;
                }
            }
            else {
                GL11.glViewport(0, 0, this.r.d, this.r.e);
            }
            if (i == 2) {
                this.g(f);
            }
            GL11.glClear(16640);
            GL11.glEnable(2884);
            ld.c("camera");
            if (this.second_renderpass) {
                this.a(f, 0);
                if (i != 2) {
                    GL11.glFrontFace(2305);
                    GL11.glDisable(12288);
                }
                else {
                    this.prev_fall = 0.0;
                    double water_to_origin = 127.64 - this.prev_fall - d2 * 2.0;
                    if (this.on_ground_delay == 200) {
                        if (!entityliving.X) {
                            final double output = this.planeCasting(d, d2, d3);
                            if (output > 0.001 || output < -0.001) {
                                this.last_water_height = 127.64 - 2.0 * output;
                            }
                            else {
                                System.out.println("null");
                            }
                        }
                        this.on_ground_delay = 0;
                    }
                    if (entityliving.z) {
                        ++this.on_ground_delay;
                    }
                    water_to_origin -= this.last_water_height;
                    GL11.glTranslatef(0.0f, (float)water_to_origin, 0.0f);
                    GL11.glScalef(1.0f, -1.0f, 1.0f);
                    float[] matrix = new float[16];
                    matrix = this.calcInverseView(0.0, 0.0, 0.0, entityliving.w + (entityliving.u - entityliving.w) * f + 180.0f, entityliving.x + (entityliving.v - entityliving.x) * f);
                    final double plane_h = (water_to_origin - 127.64) / -2.0 - 64.1;
                    this.modifyProjectionMatrix(plane_h + 0.1);
                    GL11.glFrontFace(2304);
                    if (entityliving.X) {}
                }
            }
            else {
                this.a(f, i);
            }
            yx.a((xb)this.r.h, this.r.A.E == 2);
            ld.c("frustrum");
            if (i == 1) {
                GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
            }
            if (i == 0) {
                r.a();
            }
            if (this.r.A.e < 2) {
                if (i != 1) {
                    this.a(-1, f);
                }
                ld.c("sky");
                if (i != 1) {
                    renderglobal.a(f);
                }
            }
            if (i != 1) {
                GL11.glEnable(2912);
                this.a(1, f);
                if (this.r.A.k) {
                    GL11.glShadeModel(7425);
                }
            }
            ld.c("culling");
            final mv frustrum = new mv();
            frustrum.a(d, d2, d3);
            this.r.g.a((ajo)frustrum, f);
            if (i == 0) {
                ld.c("updatechunks");
                while (!this.r.g.a(entityliving, false)) {
                    if (l == 0L) {
                        break;
                    }
                    final long l2 = l - System.nanoTime();
                    if (l2 < 0L || l2 > 1000000000L) {
                        break;
                    }
                }
            }
            if (i != 1) {
                this.a(0, f);
                GL11.glEnable(2912);
            }
            GL11.glBindTexture(3553, this.r.p.b("/terrain.png"));
            if (disable_terrain) {
                GL11.glClear(17664);
                GL11.glDisable(3553);
            }
            se.a();
            ld.c("terrain");
            if (disable_terrain) {
                this.black.bind();
            }
            renderglobal.a(entityliving, 0, (double)f);
            GL11.glShadeModel(7424);
            if (this.q == 0) {
                se.b();
                ld.c("entities");
                if (this.water_config.reflective_items || i != 2) {
                    if (this.water_config.reflect_player && i == 2) {
                        this.third_person = this.r.A.E;
                        this.r.A.E = 1;
                    }
                    renderglobal.a(entityliving.h(f), (ajo)frustrum, f);
                }
                this.b((double)f);
                ld.c("litParticles");
                if (this.water_config.reflective_items || i != 2) {
                    if (this.water_config.reflect_player && i == 2) {
                        this.r.A.E = this.third_person;
                    }
                    effectrenderer.b((ms)entityliving, f);
                }
                se.a();
                if (i != 1) {
                    this.a(0, f);
                }
                ld.c("particles");
                if (i == 0) {
                    effectrenderer.a((ms)entityliving, f);
                }
                this.a((double)f);
                if (i == 0 && this.r.z != null && entityliving.a(aan.g) && entityliving instanceof xb) {
                    final xb entityplayer = (xb)entityliving;
                    GL11.glDisable(3008);
                    ld.c("outline");
                    renderglobal.a(entityplayer, this.r.z, 0, entityplayer.ap.b(), f);
                    renderglobal.b(entityplayer, this.r.z, 0, entityplayer.ap.b(), f);
                    GL11.glEnable(3008);
                }
            }
            if (i == 0 || i == 1) {
                GL11.glDisable(3042);
                GL11.glEnable(2884);
                GL11.glBlendFunc(770, 771);
                GL11.glDepthMask(true);
                this.a(0, f);
            }
            if (disable_terrain) {
                this.black.unbind();
            }
            GL11.glEnable(3042);
            GL11.glDisable(2884);
            GL11.glBindTexture(3553, this.r.p.b("/terrain.png"));
            if (disable_terrain) {
                GL11.glEnable(3553);
                this.white.bind();
                this.white.setValueMat4f(this.white_inverse_view, this.calcInverseView(0.0, 0.0, 0.0, entityliving.w, entityliving.x));
            }
            if (i == 0 || i == 1) {
                if (this.second_renderpass && i == 0) {
                    GL11.glAlphaFunc(519, 0.0f);
                    this.transparency.bind();
                    this.transparency.setValue1f(this.transp_render_v3, this.water_config.render_v3);
                    this.transparency.setValue1f(this.transp_water, this.water_config.water_surface_transparency);
                    this.transparency.setValue1f(this.transp_waterfall, this.water_config.waterfall_transparency);
                    this.transparency.setValueVec3f(this.transp_waterfall_color, this.water_config.waterfall_color[0], this.water_config.waterfall_color[1], this.water_config.waterfall_color[2]);
                    this.transparency.setValue1i(this.transp_colorMap, 0);
                    this.transparency.setValue1i(this.transp_lightMap, 1);
                    this.transparency.setValue1i(this.transp_reflectionMap, 2);
                    GL13.glActiveTexture(33986);
                    this.framebuffer.bind_texture(0);
                    GL11.glEnable(3042);
                    GL11.glBlendFunc(770, 771);
                }
                if (this.r.A.j) {
                    ld.c("water");
                    if (this.r.A.k) {
                        GL11.glShadeModel(7425);
                    }
                    GL11.glColorMask(false, false, false, false);
                    final int i2 = renderglobal.a(entityliving, 1, (double)f);
                    if (this.r.A.g) {
                        if (kz.b == 0) {
                            GL11.glColorMask(false, true, true, true);
                        }
                        else {
                            GL11.glColorMask(true, false, false, true);
                        }
                    }
                    else {
                        GL11.glColorMask(true, true, true, true);
                    }
                    if (i2 > 0) {
                        renderglobal.a(1, (double)f);
                    }
                    GL11.glShadeModel(7424);
                }
                else {
                    ld.c("water");
                    renderglobal.a(entityliving, 1, (double)f);
                }
                if (this.second_renderpass && i == 0) {
                    this.transparency.unbind();
                    GL11.glAlphaFunc(516, 0.01f);
                }
            }
            if (i == 1 && disable_terrain) {
                this.white.unbind();
                this.black.bind();
            }
            GL11.glDepthMask(true);
            GL11.glEnable(2884);
            GL11.glDisable(3042);
            if (this.V == 1.0 && entityliving instanceof xb && this.r.z != null && !entityliving.a(aan.g)) {
                final xb entityplayer2 = (xb)entityliving;
                GL11.glDisable(3008);
                ld.c("outline");
                renderglobal.a(entityplayer2, this.r.z, 0, entityplayer2.ap.b(), f);
                if (i == 0) {
                    renderglobal.b(entityplayer2, this.r.z, 0, entityplayer2.ap.b(), f);
                }
                GL11.glEnable(3008);
            }
            ld.c("weather");
            if (i != 2) {
                this.c(f);
            }
            if (i != 1) {
                GL11.glDisable(2912);
                if (this.u == null) {}
            }
            if (this.r.A.c()) {
                ld.c("clouds");
                if (i != 1) {
                    GL11.glPushMatrix();
                    this.a(0, f);
                }
                if (this.water_config.reflective_clouds || i != 2) {
                    GL11.glEnable(2912);
                    renderglobal.b(f);
                    GL11.glDisable(2912);
                }
                if (i != 1) {
                    this.a(1, f);
                    GL11.glPopMatrix();
                }
            }
            if (i != 2) {
                ld.c("hand");
                if (this.V == 1.0) {
                    GL11.glClear(256);
                    this.b(f, i);
                }
            }
            if (this.second_renderpass) {
                if (i == 1) {
                    if (disable_terrain) {
                        this.black.unbind();
                    }
                    GL11.glEnable(3553);
                    disable_terrain = false;
                }
                this.framebuffer.unbind();
                if (i == 2) {
                    GL11.glMatrixMode(5888);
                }
            }
            else if (!this.r.A.g) {
                ld.b();
                return;
            }
        }
        if (this.second_renderpass) {
            GL11.glDisable(12288);
            GL11.glFrontFace(2305);
            this.water.bind();
            this.water.setValue1f(this.water_timer, this.timer);
            final long current_time = System.nanoTime();
            this.timer += 0.002f * (current_time - this.previous_time) / 1.3E7f;
            if (this.timer >= 1.0) {
                this.timer = 0.0f;
            }
            this.previous_time = current_time;
            this.framebuffer.bind_texture(0);
            this.water.setValue1i(this.water_colorMap, 0);
            GL13.glActiveTexture(33985);
            this.framebuffer.bind_texture(1);
            this.water.setValue1i(this.water_stencilMap, 1);
            if (this.water_config.water_render_mode <= 3) {
                GL13.glActiveTexture(33986);
                this.framebuffer.bind_texture(2);
                this.water.setValue1i(this.water_reflectedColorMap, 2);
            }
            this.water.setValueVec3f(this.water_color, this.water_config.water_color[0], this.water_config.water_color[1], this.water_config.water_color[2]);
            GL13.glActiveTexture(33984);
            GL11.glMatrixMode(5889);
            GL11.glLoadIdentity();
            GL11.glOrtho(-1.0, 1.0, -1.0, 1.0, 1.0, 40.0);
            GL11.glMatrixMode(5888);
            GL11.glLoadIdentity();
            GL11.glViewport(0, 0, this.r.d, this.r.e);
            GL11.glClear(17664);
            GL11.glColor3f(1.0f, 1.0f, 1.0f);
            GL11.glBegin(7);
            GL11.glTexCoord2f(0.0f, 1.0f);
            GL11.glVertex3f(-1.0f, 1.0f, -1.0f);
            GL11.glTexCoord2f(0.0f, 0.0f);
            GL11.glVertex3f(-1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(1.0f, 0.0f);
            GL11.glVertex3f(1.0f, -1.0f, -1.0f);
            GL11.glTexCoord2f(1.0f, 1.0f);
            GL11.glVertex3f(1.0f, 1.0f, -1.0f);
            GL11.glEnd();
            this.water.unbind();
            this.framebuffer.unbind_texture();
            this.b(f, 0);
        }
        else {
            GL11.glColorMask(true, true, true, false);
        }
        ld.b();
    }
    
    private void f() {
        float f = this.r.f.j(1.0f);
        if (!this.r.A.j) {
            f /= 2.0f;
        }
        if (f == 0.0f) {
            return;
        }
        this.ab.setSeed(this.t * 312987231L);
        final aar entityliving = this.r.i;
        final vq world = this.r.f;
        final int i = ga.c(entityliving.o);
        final int j = ga.c(entityliving.p);
        final int k = ga.c(entityliving.q);
        final byte byte0 = 10;
        double d = 0.0;
        double d2 = 0.0;
        double d3 = 0.0;
        int l = 0;
        int i2 = (int)(100.0f * f * f);
        if (this.r.A.P == 1) {
            i2 >>= 1;
        }
        else if (this.r.A.P == 2) {
            i2 = 0;
        }
        for (int j2 = 0; j2 < i2; ++j2) {
            final int k2 = i + this.ab.nextInt(byte0) - this.ab.nextInt(byte0);
            final int l2 = k + this.ab.nextInt(byte0) - this.ab.nextInt(byte0);
            final int i3 = world.e(k2, l2);
            final int j3 = world.a(k2, i3 - 1, l2);
            if (i3 <= j + byte0 && i3 >= j - byte0 && world.a().a(k2, l2).c()) {
                if (world.a().a(k2, i3, l2) > 0.2f) {
                    final float f2 = this.ab.nextFloat();
                    final float f3 = this.ab.nextFloat();
                    if (j3 > 0) {
                        if (oe.m[j3].cb == aan.h) {
                            this.r.j.a((qv)new aiv(world, (double)(k2 + f2), i3 + 0.1f - oe.m[j3].bU, (double)(l2 + f3), 0.0, 0.0, 0.0));
                        }
                        else {
                            if (this.ab.nextInt(++l) == 0) {
                                d = k2 + f2;
                                d2 = i3 + 0.1f - oe.m[j3].bU;
                                d3 = l2 + f3;
                            }
                            this.r.j.a((qv)new qj(world, (double)(k2 + f2), i3 + 0.1f - oe.m[j3].bU, (double)(l2 + f3)));
                        }
                    }
                }
            }
        }
        if (l > 0 && this.ab.nextInt(3) < this.ac++) {
            this.ac = 0;
            if (d2 > entityliving.p + 1.0 && world.e(ga.c(entityliving.o), ga.c(entityliving.q)) > ga.c(entityliving.p)) {
                this.r.f.a(d, d2, d3, "ambient.weather.rain", 0.1f, 0.5f);
            }
            else {
                this.r.f.a(d, d2, d3, "ambient.weather.rain", 0.2f, 1.0f);
            }
        }
    }
    
    protected void c(final float f) {
        final float f2 = this.r.f.j(f);
        if (f2 <= 0.0f) {
            return;
        }
        this.b((double)f);
        if (this.i == null) {
            this.i = new float[1024];
            this.j = new float[1024];
            for (int i = 0; i < 32; ++i) {
                for (int j = 0; j < 32; ++j) {
                    final float f3 = (float)(j - 16);
                    final float f4 = (float)(i - 16);
                    final float f5 = ga.c(f3 * f3 + f4 * f4);
                    this.i[i << 5 | j] = -f4 / f5;
                    this.j[i << 5 | j] = f3 / f5;
                }
            }
        }
        final aar entityliving = this.r.i;
        final vq world = this.r.f;
        final int k = ga.c(entityliving.o);
        final int l = ga.c(entityliving.p);
        final int i2 = ga.c(entityliving.q);
        final aby tessellator = aby.a;
        GL11.glDisable(2884);
        GL11.glNormal3f(0.0f, 1.0f, 0.0f);
        GL11.glEnable(3042);
        GL11.glBlendFunc(770, 771);
        GL11.glAlphaFunc(516, 0.01f);
        GL11.glBindTexture(3553, this.r.p.b("/environment/snow.png"));
        final double d = entityliving.N + (entityliving.o - entityliving.N) * f;
        final double d2 = entityliving.O + (entityliving.p - entityliving.O) * f;
        final double d3 = entityliving.P + (entityliving.q - entityliving.P) * f;
        final int j2 = ga.c(d2);
        int k2 = 5;
        if (this.r.A.j) {
            k2 = 10;
        }
        final zp[] abiomegenbase = world.a().a(k - k2, i2 - k2, k2 * 2 + 1, k2 * 2 + 1);
        final float[] af = world.a().b(k - k2, i2 - k2, k2 * 2 + 1, k2 * 2 + 1);
        int l2 = 0;
        byte byte0 = -1;
        final float f6 = this.t + f;
        if (this.r.A.j) {
            k2 = 10;
        }
        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        l2 = 0;
        for (int i3 = i2 - k2; i3 <= i2 + k2; ++i3) {
            for (int j3 = k - k2; j3 <= k + k2; ++j3) {
                final int k3 = (i3 - i2 + 16) * 32 + (j3 - k + 16);
                final float f7 = this.i[k3] * 0.5f;
                final float f8 = this.j[k3] * 0.5f;
                final zp biomegenbase = abiomegenbase[l2++];
                if (biomegenbase.c() || biomegenbase.b()) {
                    final int l3 = world.e(j3, i3);
                    int i4 = l - k2;
                    int j4 = l + k2;
                    if (i4 < l3) {
                        i4 = l3;
                    }
                    if (j4 < l3) {
                        j4 = l3;
                    }
                    final float f9 = 1.0f;
                    int k4 = l3;
                    if (k4 < j2) {
                        k4 = j2;
                    }
                    if (i4 != j4) {
                        this.ab.setSeed(j3 * j3 * 3121 + j3 * 45238971 ^ i3 * i3 * 418711 + i3 * 13761);
                        final float f10 = af[l2 - 1];
                        if (world.a().a(f10, l3) >= 0.15f) {
                            if (byte0 != 0) {
                                if (byte0 >= 0) {
                                    tessellator.a();
                                }
                                byte0 = 0;
                                GL11.glBindTexture(3553, this.r.p.b("/environment/rain.png"));
                                tessellator.b();
                            }
                            final float f11 = ((this.t + j3 * j3 * 3121 + j3 * 45238971 + i3 * i3 * 418711 + i3 * 13761 & 0x1F) + f) / 32.0f * (3.0f + this.ab.nextFloat());
                            final double d4 = j3 + 0.5f - entityliving.o;
                            final double d5 = i3 + 0.5f - entityliving.q;
                            final float f12 = ga.a(d4 * d4 + d5 * d5) / k2;
                            final float f13 = 1.0f;
                            tessellator.b(world.b(j3, k4, i3, 0));
                            tessellator.a(f13, f13, f13, ((1.0f - f12 * f12) * 0.5f + 0.5f) * f2);
                            tessellator.b(-d * 1.0, -d2 * 1.0, -d3 * 1.0);
                            tessellator.a(j3 - f7 + 0.5, (double)i4, i3 - f8 + 0.5, (double)(0.0f * f9), (double)(i4 * f9 / 4.0f + f11 * f9));
                            tessellator.a(j3 + f7 + 0.5, (double)i4, i3 + f8 + 0.5, (double)(1.0f * f9), (double)(i4 * f9 / 4.0f + f11 * f9));
                            tessellator.a(j3 + f7 + 0.5, (double)j4, i3 + f8 + 0.5, (double)(1.0f * f9), (double)(j4 * f9 / 4.0f + f11 * f9));
                            tessellator.a(j3 - f7 + 0.5, (double)j4, i3 - f8 + 0.5, (double)(0.0f * f9), (double)(j4 * f9 / 4.0f + f11 * f9));
                            tessellator.b(0.0, 0.0, 0.0);
                        }
                        else {
                            if (byte0 != 1) {
                                if (byte0 >= 0) {
                                    tessellator.a();
                                }
                                byte0 = 1;
                                GL11.glBindTexture(3553, this.r.p.b("/environment/snow.png"));
                                tessellator.b();
                            }
                            final float f14 = ((this.t & 0x1FF) + f) / 512.0f;
                            final float f15 = this.ab.nextFloat() + f6 * 0.01f * (float)this.ab.nextGaussian();
                            final float f16 = this.ab.nextFloat() + f6 * (float)this.ab.nextGaussian() * 0.001f;
                            final double d6 = j3 + 0.5f - entityliving.o;
                            final double d7 = i3 + 0.5f - entityliving.q;
                            final float f17 = ga.a(d6 * d6 + d7 * d7) / k2;
                            final float f18 = 1.0f;
                            tessellator.b((world.b(j3, k4, i3, 0) * 3 + 15728880) / 4);
                            tessellator.a(f18, f18, f18, ((1.0f - f17 * f17) * 0.3f + 0.5f) * f2);
                            tessellator.b(-d * 1.0, -d2 * 1.0, -d3 * 1.0);
                            tessellator.a(j3 - f7 + 0.5, (double)i4, i3 - f8 + 0.5, (double)(0.0f * f9 + f15), (double)(i4 * f9 / 4.0f + f14 * f9 + f16));
                            tessellator.a(j3 + f7 + 0.5, (double)i4, i3 + f8 + 0.5, (double)(1.0f * f9 + f15), (double)(i4 * f9 / 4.0f + f14 * f9 + f16));
                            tessellator.a(j3 + f7 + 0.5, (double)j4, i3 + f8 + 0.5, (double)(1.0f * f9 + f15), (double)(j4 * f9 / 4.0f + f14 * f9 + f16));
                            tessellator.a(j3 - f7 + 0.5, (double)j4, i3 - f8 + 0.5, (double)(0.0f * f9 + f15), (double)(j4 * f9 / 4.0f + f14 * f9 + f16));
                            tessellator.b(0.0, 0.0, 0.0);
                        }
                    }
                }
            }
        }
        if (byte0 >= 0) {
            tessellator.a();
        }
        GL11.glEnable(2884);
        GL11.glDisable(3042);
        GL11.glAlphaFunc(516, 0.1f);
        this.a((double)f);
    }
    
    public void b() {
        final aec scaledresolution = new aec(this.r.A, this.r.d, this.r.e);
        GL11.glClear(256);
        GL11.glMatrixMode(5889);
        GL11.glLoadIdentity();
        GL11.glOrtho(0.0, scaledresolution.a, scaledresolution.b, 0.0, 1000.0, 3000.0);
        GL11.glMatrixMode(5888);
        GL11.glLoadIdentity();
        GL11.glTranslatef(0.0f, 0.0f, -2000.0f);
    }
    
    private void g(final float f) {
        final vq world = this.r.f;
        final aar entityliving = this.r.i;
        float f2 = 1.0f / (4 - this.r.A.e);
        f2 = 1.0f - (float)Math.pow(f2, 0.25);
        final bk vec3d = world.a((ms)this.r.i, f);
        final float f3 = (float)vec3d.a;
        final float f4 = (float)vec3d.b;
        final float f5 = (float)vec3d.c;
        final bk vec3d2 = world.g(f);
        this.n = (float)vec3d2.a;
        this.o = (float)vec3d2.b;
        this.p = (float)vec3d2.c;
        if (this.r.A.e < 2) {
            final bk vec3d3 = (ga.a(world.e(f)) <= 0.0f) ? bk.b(1.0, 0.0, 0.0) : bk.b(-1.0, 0.0, 0.0);
            float f6 = (float)entityliving.i(f).b(vec3d3);
            if (f6 < 0.0f) {
                f6 = 0.0f;
            }
            if (f6 > 0.0f) {
                final float[] af = world.y.a(world.c(f), f);
                if (af != null) {
                    f6 *= af[3];
                    this.n = this.n * (1.0f - f6) + af[0] * f6;
                    this.o = this.o * (1.0f - f6) + af[1] * f6;
                    this.p = this.p * (1.0f - f6) + af[2] * f6;
                }
            }
        }
        this.n += (f3 - this.n) * f2;
        this.o += (f4 - this.o) * f2;
        this.p += (f5 - this.p) * f2;
        final float f7 = world.j(f);
        if (f7 > 0.0f) {
            final float f8 = 1.0f - f7 * 0.5f;
            final float f9 = 1.0f - f7 * 0.4f;
            this.n *= f8;
            this.o *= f8;
            this.p *= f9;
        }
        final float f10 = world.i(f);
        if (f10 > 0.0f) {
            final float f11 = 1.0f - f10 * 0.5f;
            this.n *= f11;
            this.o *= f11;
            this.p *= f11;
        }
        final int i = yx.a(this.r.f, entityliving, f);
        if (this.U) {
            final bk vec3d4 = world.f(f);
            this.n = (float)vec3d4.a;
            this.o = (float)vec3d4.b;
            this.p = (float)vec3d4.c;
        }
        else if (i != 0 && oe.m[i].cb == null) {
            this.n = 0.02f;
            this.o = 0.02f;
            this.p = 0.2f;
        }
        else if (i != 0 && oe.m[i].cb == aan.h) {
            this.n = 0.6f;
            this.o = 0.1f;
            this.p = 0.0f;
        }
        final float f12 = this.ad + (this.ae - this.ad) * f;
        this.n *= f12;
        this.o *= f12;
        this.p *= f12;
        double d = (entityliving.O + (entityliving.p - entityliving.O) * f) * world.y.j();
        if (entityliving.a(yg.q)) {
            final int j = entityliving.b(yg.q).b();
            if (j < 20) {
                d *= 1.0f - j / 20.0f;
            }
            else {
                d = 0.0;
            }
        }
        if (d < 1.0) {
            if (d < 0.0) {
                d = 0.0;
            }
            d *= d;
            this.n *= (float)d;
            this.o *= (float)d;
            this.p *= (float)d;
        }
        if (this.r.A.g) {
            final float f13 = (this.n * 30.0f + this.o * 59.0f + this.p * 11.0f) / 100.0f;
            final float f14 = (this.n * 30.0f + this.o * 70.0f) / 100.0f;
            final float f15 = (this.n * 30.0f + this.p * 70.0f) / 100.0f;
            this.n = f13;
            this.o = f14;
            this.p = f15;
        }
        GL11.glClearColor(this.n, this.o, this.p, 0.0f);
    }
    
    private void a(final int i, final float f) {
        final aar entityliving = this.r.i;
        boolean flag = false;
        if (entityliving instanceof xb) {
            flag = ((xb)entityliving).aT.d;
        }
        if (i == 999) {
            GL11.glFog(2918, this.a(0.0f, 0.0f, 0.0f, 1.0f));
            GL11.glFogi(2917, 9729);
            GL11.glFogf(2915, 0.0f);
            GL11.glFogf(2916, 8.0f);
            if (GLContext.getCapabilities().GL_NV_fog_distance) {
                GL11.glFogi(34138, 34139);
            }
            GL11.glFogf(2915, 0.0f);
            return;
        }
        GL11.glFog(2918, this.a(this.n, this.o, this.p, 1.0f));
        GL11.glNormal3f(0.0f, -1.0f, 0.0f);
        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        final int j = yx.a(this.r.f, entityliving, f);
        if (entityliving.a(yg.q)) {
            float f2 = 5.0f;
            final int k = entityliving.b(yg.q).b();
            if (k < 20) {
                f2 = 5.0f + (this.s - 5.0f) * (1.0f - k / 20.0f);
            }
            GL11.glFogi(2917, 9729);
            if (i < 0) {
                GL11.glFogf(2915, 0.0f);
                GL11.glFogf(2916, f2 * 0.8f);
            }
            else {
                GL11.glFogf(2915, f2 * 0.25f);
                GL11.glFogf(2916, f2);
            }
            if (GLContext.getCapabilities().GL_NV_fog_distance) {
                GL11.glFogi(34138, 34139);
            }
        }
        else if (this.U) {
            GL11.glFogi(2917, 2048);
            GL11.glFogf(2914, 0.1f);
            float f3 = 1.0f;
            float f4 = 1.0f;
            float f5 = 1.0f;
            if (this.r.A.g) {
                final float f6 = (f3 * 30.0f + f4 * 59.0f + f5 * 11.0f) / 100.0f;
                final float f7 = (f3 * 30.0f + f4 * 70.0f) / 100.0f;
                final float f8 = (f3 * 30.0f + f5 * 70.0f) / 100.0f;
                f3 = f6;
                f4 = f7;
                f5 = f8;
            }
        }
        else if (j > 0 && oe.m[j].cb == null) {
            GL11.glFogi(2917, 2048);
            if (!entityliving.a(yg.o)) {
                GL11.glFogf(2914, 0.1f);
            }
            else {
                GL11.glFogf(2914, 0.05f);
            }
            float f9 = 0.4f;
            float f10 = 0.4f;
            float f11 = 0.9f;
            if (this.r.A.g) {
                final float f12 = (f9 * 30.0f + f10 * 59.0f + f11 * 11.0f) / 100.0f;
                final float f13 = (f9 * 30.0f + f10 * 70.0f) / 100.0f;
                final float f14 = (f9 * 30.0f + f11 * 70.0f) / 100.0f;
                f9 = f12;
                f10 = f13;
                f11 = f14;
            }
        }
        else if (j > 0 && oe.m[j].cb == aan.h) {
            GL11.glFogi(2917, 2048);
            GL11.glFogf(2914, 2.0f);
            float f15 = 0.4f;
            float f16 = 0.3f;
            float f17 = 0.3f;
            if (this.r.A.g) {
                final float f18 = (f15 * 30.0f + f16 * 59.0f + f17 * 11.0f) / 100.0f;
                final float f19 = (f15 * 30.0f + f16 * 70.0f) / 100.0f;
                final float f20 = (f15 * 30.0f + f17 * 70.0f) / 100.0f;
                f15 = f18;
                f16 = f19;
                f17 = f20;
            }
        }
        else {
            float f21 = this.s;
            if (this.r.f.y.i() && !flag) {
                double d = ((entityliving.b(f) & 0xF00000) >> 20) / 16.0 + (entityliving.O + (entityliving.p - entityliving.O) * f + 4.0) / 32.0;
                if (d < 1.0) {
                    if (d < 0.0) {
                        d = 0.0;
                    }
                    d *= d;
                    float f22 = 100.0f * (float)d;
                    if (f22 < 5.0f) {
                        f22 = 5.0f;
                    }
                    if (f21 > f22) {
                        f21 = f22;
                    }
                }
            }
            GL11.glFogi(2917, 9729);
            if (i < 0) {
                GL11.glFogf(2915, 0.0f);
                GL11.glFogf(2916, f21 * 0.8f);
            }
            else {
                GL11.glFogf(2915, f21 * 0.25f);
                GL11.glFogf(2916, f21);
            }
            if (GLContext.getCapabilities().GL_NV_fog_distance) {
                GL11.glFogi(34138, 34139);
            }
            if (this.r.f.y.d) {
                GL11.glFogf(2915, 0.0f);
            }
        }
        GL11.glEnable(2903);
        GL11.glColorMaterial(1028, 4608);
    }
    
    private FloatBuffer a(final float f, final float f1, final float f2, final float f3) {
        this.m.clear();
        this.m.put(f).put(f1).put(f2).put(f3);
        this.m.flip();
        return this.m;
    }
    
    static {
        kz.a = false;
    }
}
